VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsBanlist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private DatabasePath As String
Private Banlist() As New clsBans

Public Function Count() As Long
On Error Resume Next
    Count = UBound(Banlist)
End Function

Public Function Getbanlist() As clsBans()
    Getbanlist = Banlist
End Function

Public Function GetByIndex(Index As Long) As clsBans
On Error GoTo hErr:
    Set GetByIndex = Banlist(Index)
    Exit Function
hErr:
    Set GetByIndex = New clsBans
End Function

Public Function GetByName(Username As String) As clsBans

    Dim I As Integer
    I = Find(Username)
    If I > -1 Then
        Set GetByName = Banlist(I)
        Exit Function
    End If
    Dim Temp As New clsGrouping
    Temp.Groupname = "#INVALID#"
    Temp.Attributes = 0
    Set GetByName = Temp

End Function
Public Sub SetUser(Index As Long, User As clsGrouping)
    Set Banlist(Index) = User
End Sub

Private Function Same(Str1 As String, Str2 As String) As Boolean
    Same = LCase$(Str1) = LCase$(Str2)
End Function

Public Sub Clear()
    ReDim Banlist(0)
End Sub
Public Function Add(Banname As String, Optional AddTime As String, Optional AddDate As String, Optional AddBy As String, Optional Out As String) As Boolean
    
    If Find(Banname) > -1 Then: Out = "User already exists!": Exit Function
    If LenB(AddTime) = 0 Then AddTime = Time
    If LenB(AddDate) = 0 Then AddDate = Date
    If LenB(AddBy) = 0 Then AddBy = "[Knight]"
    
    Dim IU As New clsBans
    With IU
        .Username = Banname
        .Addedby = AddBy
        .AddedDate = AddDate
        .AddedTime = AddTime
        .BanTime = GetTickCount()
    End With
    
    If LenB(Banlist(0).Username) = 0 Then
        Set Banlist(0) = IU
    Else
        ReDim Preserve Banlist(UBound(Banlist) + 1)
        Set Banlist(UBound(Banlist)) = IU
    End If

    Add = True
End Function
Public Function findPattern(ByVal User As String) As Long
    If LenB(User) = 0 Then findPattern = -2: Exit Function
    Dim I As Integer
    User = LCase$(User)
    For I = UBound(Banlist) To 0 Step -1
        If User = LCase$(Banlist(I).Username) Then
            findPattern = I
            Exit Function
        End If
    Next I
    findPattern = -1
End Function

Public Function Find(ByVal User As String) As Long
    If LenB(User) = 0 Then Find = -2: Exit Function
    Dim I As Integer
    User = LCase$(User)
    For I = UBound(Banlist) To 0 Step -1
        If User = LCase$(Banlist(I).Username) Then
            Find = I
            Exit Function
        End If
    Next I
    Find = -1
End Function

Public Function matchUser(ByVal Match As String, ByRef Result() As Long) As Boolean
    If LenB(Match) = 0 Then matchUser = False: Exit Function
    Dim I() As Long, X As Integer
    ReDim I(0): I(0) = -1
    For X = UBound(Banlist) To 0 Step -1
        If Matches(Banlist(X).Username, Match) Then
            If I(0) = -1 Then
                I(0) = X
            Else
                ReDim Preserve I(UBound(I) + 1)
                I(UBound(I)) = X
            End If
        End If
    Next X
    If I(0) <> -1 Then matchUser = True
    Result = I
End Function

Public Function Remove(ByVal User As String) As Boolean
    Dim I As Long, R As Integer
    User = LCase$(User)
    If UBound(Banlist) = 0 Then
        If LCase$(Banlist(0).Username) = User Then
            ReDim Banlist(0)
            Remove = True
            Exit Function
        End If
    End If
    For I = 0 To UBound(Banlist)
        If User = LCase$(Banlist(I).Username) Then
            For R = I To UBound(Banlist) - 1
                Set Banlist(R) = Banlist(R + 1)
            Next R
            ReDim Preserve Banlist(UBound(Banlist) - 1)
            Remove = True
            Exit Function
        End If
    Next I
    Exit Function
End Function
Private Sub Class_Initialize()
    ReDim Banlist(0) As New clsBans
End Sub

Private Sub Class_Terminate()
    ReDim Banlist(0)
End Sub


