VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsUsers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Users() As New clsUserInfo

Public Function Count() As Integer
    Count = UBound(Users)
End Function

Public Sub Clear()
    ReDim Users(0)
End Sub

Public Sub Add(Username As String, Statstring As String, Flags As Long, Ping As Long)
    
    If UBound(Users) > 0 Or Users(0).Account = Suffix(Username) Then Remove Username
    Dim U As New clsUserInfo
    U.Username = Username
    U.Statstring = Statstring
    U.Flags = Flags
    U.Ping = Ping
    U.TickJoin = GetTickCount()
    U.TickTalk = GetTickCount()
    
    If (LenB(Users(0).Username) = 0) Then
        Set Users(0) = U
    Else
        ReDim Preserve Users(UBound(Users) + 1)
        Set Users(UBound(Users)) = U
    End If

End Sub

Public Sub Insert(ByRef User As clsUserInfo)
    
    If UBound(Users) > 0 Or Users(0).Account = Suffix(Username) Then Remove Username
    Dim U As New clsUserInfo
    U.Username = User.Username
    U.Statstring = User.Statstring
    U.Flags = User.Flags
    U.Ping = User.Ping
    U.TickJoin = User.TickJoin
    U.TickTalk = User.TickTalk
    
    Set User = U
    
    If (LenB(Users(0).Username) = 0) Then
        Set Users(0) = U
    Else
        ReDim Preserve Users(UBound(Users) + 1)
        Set Users(UBound(Users)) = U
    End If

End Sub

Public Function Match(strMatch As String) As String()
    Dim I As Integer, S() As String
    ReDim S(0)
    For I = 0 To UBound(Users)
        If Matches(Users(I).Account, strMatch) Then
            If LenB(S(0)) = 0 Then
                S(0) = Users(I).Account
            Else
                ReDim Preserve S(UBound(S) + 1)
                S(UBound(S)) = Users(I).Account
            End If
        End If
    Next I
    Match = S
End Function

Public Sub Remove(Username As String)
    Dim I As Integer
    I = Find(Username)
    If I > -1 Then
        If I = 0 Then
            Set Users(0) = New clsUserInfo
        Else
            Dim R As Integer
            For R = I To UBound(Users) - 1
                Set Users(R) = Users(R + 1)
            Next
            ReDim Preserve Users(UBound(Users) - 1)
        End If
    End If
End Sub

Public Sub RemoveIndex(Index As Integer)
    Dim I As Integer
    I = Index
    If I > -1 Then
        If I = 0 Then
            Set Users(0) = New clsUserInfo
        Else
            Dim R As Integer
            For R = I To UBound(Users) - 1
                Set Users(R) = Users(R + 1)
            Next
            ReDim Preserve Users(UBound(Users) - 1)
        End If
    End If
End Sub

Public Sub Update(Username As String, Flags As Long, Ping As Long)

    Dim I As Integer
    I = Find(Username)
    If I > -1 Then
        Users(I).Flags = Flags
        Users(I).Ping = Ping
        Users(I).Username = Username
    End If
    Exit Sub

End Sub

Public Function Find(ByVal Username As String) As Integer

    Dim I As Integer
    Username = LCase$(Suffix(Username))
    For I = 0 To UBound(Users)
        If (Username = LCase$(Users(I).Account)) Then
            Find = I
            Exit Function
        End If
    Next I
    Find = -1
    Exit Function

End Function

Public Function GetByName(Username As String) As clsUserInfo

    Dim I As Integer
    I = Find(Username)
    If I > -1 Then
        Set GetByName = Users(I)
    End If
    Exit Function

End Function

Public Function GetByIndex(Index As Integer) As clsUserInfo

    If Index < 0 Or Index > UBound(Users) Then Exit Function
    Set GetByIndex = Users(Index)
    Exit Function

End Function

Private Sub Class_Initialize()
    ReDim Users(0) As New clsUserInfo
End Sub

Private Sub Class_Terminate()
    ReDim Users(0)
End Sub

