Attribute VB_Name = "modCommands"
Option Explicit

Public Sub HandleCommands(Data As String, User As clsDatabase, Ping As Long, Optional InBot As Boolean = False, Optional Whisper As Boolean = False)
Dim Command As String, Args As String, Splt() As String, ModifyUser As clsDatabase, TempIndex As Integer, ModifyGroup As clsGrouping
Dim I As Integer, ListingUsers As String, Count As Integer, TempUser As clsDatabase, Confirm As Boolean, TempString As String, BanCount As Long, RealmName As String
Dim ModifiedBy As String
  
  If InStrB(Data, Space$(1)) <> 0 Then
      Command = Split(Data, Space$(1))(0)
      Args = Split(Data, Space$(1), 2)(1)
  Else
      Command = Data
  End If

Select Case LCase$(Command)

' Flag A
    Case "setuser", "set", "setw"
        If ((ATTR_A And User.Flags) = ATTR_A) Or ((ATTR_D And User.Flags) = ATTR_D) Or ((ATTR_O And User.Flags) = ATTR_O) Then
            If InStrB(Args, Space$(1)) <> 0 Then
                Splt = Split(Args, Space$(1))
                    If LCase$(Command) = "setw" Then
                        TempIndex = Database.Find(Splt(0) & Realm)
                        RealmName = Splt(0) & Realm
                    Else
                        TempIndex = Database.Find(Splt(0))
                        RealmName = Splt(0)
                    End If
                    
                    If (TempIndex <> -1) Then
                        Set ModifyUser = Database.GetByIndex(TempIndex)
                    End If
                    If (TempIndex <> -1) Then
                        If Left$(Splt(1), 1) = "'" Then
                            If Groups.Find(Mid$(Splt(1), 2)) = -1 Then
                                SendMessage "Group " & AddQuotes(Mid$(Splt(1), 2)) & " does not exist.", User.Username, Whisper, InBot
                                Exit Sub
                            End If
                            If (Database.Update(User, "'", TempIndex, Mid(Splt(1), 2))) Then
                                SendMessage "Updated user " & AddQuotes(ModifyUser.Username) & " to the group " & Splt(1) & "'!", User.Username, Whisper, InBot
                                countUserMod = countUserMod + 1
                            Else
                                SendMessage "You have insufficient access to update that user to the specified group.", User.Username, Whisper, InBot
                            End If
                        Else
                                If (Database.Update(User, vbNullString, TempIndex, Splt(1))) Then
                                    If (Database.GetByIndex(TempIndex).Flags = 0) Then
                                        SendMessage "All the flags for " & AddQuotes(ModifyUser.Username) & " have been removed, user has been deleted.", User.Username, Whisper, InBot
                                        Database.Remove ModifyUser.Username
                                    Else
                                        SendMessage "Updated user " & AddQuotes(ModifyUser.Username) & " attributes to " & ModifyUser.AttributeString & "!", User.Username, Whisper, InBot
                                        countUserMod = countUserMod + 1
                                        If (ATTR_B And ModifyUser.Attributes) = ATTR_B Then
                                            If ModifyUser.Safelisted = False Then
                                                AddQ "/ban " & ModifyUser.Username & " autobanned"
                                            End If
                                        End If
                                    End If
                                Else
                                    SendMessage "You have insufficient access to update that user with those specified flags.", User.Username, Whisper, InBot
                                End If
                        End If
                    Else
                        If Left$(Splt(1), 1) = "'" Then
                            If Groups.Find(Mid$(Splt(1), 2)) = -1 Then
                                SendMessage "Group " & AddQuotes(Mid$(Splt(1), 2)) & " does not exist.", User.Username, Whisper, InBot
                                Exit Sub
                            End If
                            
                            If (Database.Add(RealmName, vbNullString, Mid$(Splt(1), 2), , , User.Username, , True, User.Flags)) Then
                                SendMessage "Added user " & AddQuotes(RealmName) & " to the group " & Splt(1) & "'!", User.Username, Whisper, InBot
                                countUserMod = countUserMod + 1
                            Else
                                SendMessage "You have insufficient access to add that user to the specified group.", User.Username, Whisper, InBot
                            End If
                        Else
                            If (Database.Add(RealmName, Splt(1), , , , User.Username, , True, User.Flags)) Then
                                SendMessage "Added user " & AddQuotes(RealmName) & " to the database with attributes of " & AttributeToString(StringToAttribute(Splt(1))) & "!", User.Username, Whisper, InBot
                                countUserMod = countUserMod + 1
                                If InStr(LCase$(Splt(1)), "b") > 0 And InStr(LCase$(Splt(1)), "s") = 0 Then
                                    AddQ "/ban " & RealmName & " autobanned"
                                End If
                            Else
                                SendMessage "You have insufficient access to add that user with those specified flags.", User.Username, Whisper, InBot
                            End If
                        End If
                    End If
            End If
        End If
    Case "remuser", "rem", "remw"
        If ((ATTR_A And User.Flags) = ATTR_A) Or ((ATTR_D And User.Flags) = ATTR_D) Or ((ATTR_O And User.Flags) = ATTR_O) Then
            If LCase$(Command) = "remw" Then
                Args = Args & Realm
                TempIndex = Database.Find(Args)
            Else
                TempIndex = Database.Find(Args)
            End If
            
            If (TempIndex = -1) Then
                SendMessage "User " & AddQuotes(Args) & " could not be found in the database.", User.Username, Whisper, InBot
                Exit Sub
            End If
            
            If (Database.CanAdd(User.Flags, Database.GetByIndex(TempIndex).Flags, Database.GetByIndex(TempIndex).Flags)) Then
                Database.Remove Args
                countUserMod = countUserMod + 1
                SendMessage Args & " has been successfully removed from the database!", User.Username, Whisper, InBot
            Else
                SendMessage "You have insufficient access to remove that user.", User.Username, Whisper, InBot
            End If
        End If
    
    Case "setgroup", "setg"
        If ((ATTR_A And User.Flags) = ATTR_A) Then
            If InStrB(Args, Space$(1)) <> 0 Then
                Splt = Split(Args, Space$(1))
                    TempIndex = Groups.Find(Splt(0))
                    If (TempIndex <> -1) Then
                        Set ModifyGroup = Groups.GetByIndex(TempIndex)
                    End If
                    
                    If (TempIndex <> -1) Then
                        If Groups.Update(TempIndex, Splt(1)) Then
                            SendMessage "Updated group " & AddQuotes(ModifyGroup.Groupname) & " attributes to " & ModifyGroup.AttributeString & "!", User.Username, Whisper, InBot
                            countGroupMod = countGroupMod + 1
                        End If
                    Else
                        If Groups.Add(Splt(0), Splt(1), , , User.Username) Then
                            SendMessage "Added " & AddQuotes(Splt(0)) & " to the group list with attributes of " & UCase(Splt(1)) & "!", User.Username, Whisper, InBot
                            countGroupMod = countGroupMod + 1
                        End If
                    End If
                End If
            End If
                        
    Case "remgroup", "remg"
        If ((ATTR_A And User.Flags) = ATTR_A) Then
            TempIndex = Groups.Find(Args)
            If (TempIndex = -1) Then
                SendMessage "Group " & AddQuotes(Args) & " was not found in the group list.", User.Username, Whisper, InBot
                Exit Sub
            Else
                Groups.Remove Args
                SendMessage Args & " has been successfully removed from the group list!", User.Username, Whisper, InBot
                countGroupMod = countGroupMod + 1
            End If
        End If
    Case "reconnect"
        If ((ATTR_A And User.Flags) = ATTR_A) Then
            LoadSettings
            Disconnect
            Connect
        End If
    Case "disconnect"
        If ((ATTR_A And User.Flags) = ATTR_A) Then
            AddChat vbRed, "You have been disconnected from Battle.net."
            Disconnect
        End If
        
    Case "quit"
        If ((ATTR_A And User.Flags) = ATTR_A) Then
            Unload frmMain
        End If
    Case "zap"
        If ((ATTR_A And User.Flags) = ATTR_A) Then
            Database.Remove Args
            If (Database.Add(Args, "Z", , , , User.Username, , True, User.Flags)) Then
                AddQ "/ban " & Args & " zapped"
            End If
        End If
    Case "join"
        If ((ATTR_A And User.Flags) = ATTR_A) Then
            If LenB(Args) = 0 Then
                SendMessage "You must specify a valid channel to join.", User.Username, Whisper, InBot
                Exit Sub
            End If
            AddQ "/join " & Args
        End If
     Case "reset"
        If ((ATTR_A And User.Flags) = ATTR_A) Then
            countUserMod = 0
            countGroupMod = 0
            countWhisper = 0
            countBanned = 0
            countUnbanned = 0
            SendMessage "All the stats have been reset.", User.Username, Whisper, InBot
        End If
    Case "clansafelist"
        If ((ATTR_A And User.Flags) = ATTR_A) Then
            If Warcraft3 Then
                For I = 0 To Clan.Count
                    If Database.GetByName(Clan.GetByIndex(I).Username).Safelisted = False Then
                        If (Database.Add(Clan.GetByIndex(I).Username, "S", , , , User.Username, , True, User.Flags)) Then
                            Count = Count + 1
                        End If
                    End If
                Next I
                
                If Count = 0 Then
                    SendMessage "No members of this clan can be safelisted.", User.Username, Whisper, InBot
                Else
                    SendMessage "There were " & Count & " members of this clan safelisted.", User.Username, Whisper, InBot
                End If
            Else
                SendMessage "I must be on Warcraft III to do that.", User.Username, Whisper, InBot
            End If
        End If
                        
            
' Flag C
    Case "account"
         If ((ATTR_C And User.Flags) = ATTR_C) Then
            If LenB(Args) = 0 Then
                SendMessage "You must specify a valid value to change the account.", User.Username, Whisper, InBot
                Exit Sub
            End If
            SendMessage "The username has been changed from '" & Config.Username & "' to '" & Args & "'!", User.Username, Whisper, InBot
            Config.Username = Args
            Username = Args
         End If
    Case "password"
         If ((ATTR_C And User.Flags) = ATTR_C) Then
            If LenB(Args) = 0 Then
                SendMessage "You must specify a valid value to change the password.", User.Username, Whisper, InBot
                Exit Sub
            End If
            SendMessage "The password has been changed to '" & Args & "'!", User.Username, Whisper, InBot
            Config.Password = Args
            Password = Args
         End If
    Case "server"
         If ((ATTR_C And User.Flags) = ATTR_C) Then
            If LenB(Args) = 0 Then
                SendMessage "You must specify a valid value to change the Server.", User.Username, Whisper, InBot
                Exit Sub
            End If
            SendMessage "The server has been changed from '" & Config.Server & "' to '" & Args & "'!", User.Username, Whisper, InBot
            Config.Server = Args
            Server = Args
         End If
    Case "client"
         If ((ATTR_C And User.Flags) = ATTR_C) Then
            If LenB(Args) = 0 Then
                SendMessage "You must specify a valid value to change the client.", User.Username, Whisper, InBot
                Exit Sub
            End If
            SendMessage "The client has been changed from '" & Config.Client & "' to '" & Args & "'!", User.Username, Whisper, InBot
            Config.Client = Args
            Trigger = Config.Trigger
            Client = Args
         End If
    Case "cdkey"
         If ((ATTR_C And User.Flags) = ATTR_C) Then
            If LenB(Args) = 0 Then
                SendMessage "You must specify a valid value to change the normal cdkey.", User.Username, Whisper, InBot
                Exit Sub
            End If
            SendMessage "The normal cdkey has been changed to '" & Args & "'!", User.Username, Whisper, InBot
            Config.CDKey1 = Args
            CDKey1 = Args
         End If
    Case "cdkeyexp"
         If ((ATTR_C And User.Flags) = ATTR_C) Then
            If LenB(Args) = 0 Then
                SendMessage "You must specify a valid value to change the expansion cdkey.", User.Username, Whisper, InBot
                Exit Sub
            End If
            SendMessage "The expansion cdkey has been changed to '" & Args & "'!", User.Username, Whisper, InBot
            Config.CDKey2 = Args
            CDKey2 = Args
         End If
    Case "home"
         If ((ATTR_C And User.Flags) = ATTR_C) Then
            If LenB(Args) = 0 Then
                SendMessage "You must specify a valid value to change the home channel.", User.Username, Whisper, InBot
                Exit Sub
            End If
            SendMessage "The home channel has been changed from '" & Config.Channel & "' to '" & Args & "'!", User.Username, Whisper, InBot
            Config.Channel = Args
            Channel = Args
         End If
    Case "trigger"
         If ((ATTR_C And User.Flags) = ATTR_C) Then
            If LenB(Args) = 0 Then
                SendMessage "You must specify a valid value to change the trigger.", User.Username, Whisper, InBot
                Exit Sub
            End If
            SendMessage "The trigger has been set to: " & Args, User.Username, Whisper, InBot
            Config.Trigger = Args
            Trigger = Config.Trigger
         End If
    Case "bnlsserver"
         If ((ATTR_C And User.Flags) = ATTR_C) Then
            If LenB(Args) = 0 Then
                SendMessage "You must specify a valid value to change the BNLS Server.", User.Username, Whisper, InBot
                Exit Sub
            End If
            SendMessage "The BNLS Server has been changed from '" & Config.BNLSServer & "' to '" & Args & "'!", User.Username, Whisper, InBot
            Config.BNLSServer = Args
         End If
    Case "email"
         If ((ATTR_C And User.Flags) = ATTR_C) Then
            If LenB(Args) = 0 Then
                SendMessage "You must specify a valid value to change the e-mail address.", User.Username, Whisper, InBot
                Exit Sub
            End If
            SendMessage "The e-mail address has been changed to '" & Args & "'!", User.Username, Whisper, InBot
            Config.Email = Args
            Email = Args
         End If
    Case "realm"
         If ((ATTR_C And User.Flags) = ATTR_C) Then
            If LenB(Args) = 0 Then
                SendMessage "You must specify a valid value to change the realm.", User.Username, Whisper, InBot
                Exit Sub
            End If
            SendMessage "The realm has been changed to '@" & Args & "'!", User.Username, Whisper, InBot
            Config.RealmName = Args
            Realm = "@" & Args
         End If
    Case "whisper"
         If ((ATTR_C And User.Flags) = ATTR_C) Then
            If LCase$(Args) = "on" Then
                Config.Whisper = Args
                Whisperback = True
                SendMessage "Whisper back has been enabled!", User.Username, Whisper, InBot
            ElseIf LCase$(Args) = "off" Then
                Config.Whisper = Args
                Whisperback = False
                SendMessage "Whisper back has been disabled.", User.Username, Whisper, InBot
            Else
                SendMessage "You must specify a valid value to make the bot whisper back.", User.Username, Whisper, InBot
            End If
         End If
' Flag I
    Case "finduser", "find"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            TempIndex = Database.Find(Args)
            If InStr(Args, "*") <> 0 Then
                For I = 0 To Database.Count
                    If Matches(Database.GetByIndex(I).Username, Args) = True Then
                        Confirm = True
                        Count = Count + 1
                        ListingUsers = ListingUsers + Database.GetByIndex(I).Username & " => " & Database.GetByIndex(I).FlagsToString & ", "
                        If (Count = 6) Or I = Database.Count And Confirm = True Then
                            SendMessage "Found Users: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                            ListingUsers = vbNullString
                            Count = 0
                        End If
                    Else
                        If (Count = 6) Or I = Database.Count And Confirm = True Then
                            SendMessage "Found Users: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                            ListingUsers = vbNullString
                            Count = 0
                        End If
                    End If
                Next I
                If Count = 0 And Confirm = False Then
                    SendMessage "There are no users in the database that are similar to " & AddQuotes(Args), User.Username, Whisper, InBot
                End If
            Else
                If (TempIndex <> -1) Then
                    If Database.GetByIndex(TempIndex).Group <> vbNullString Then
                        SendMessage "Found user " & AddQuotes(Args) & " => " & Database.GetByIndex(TempIndex).FlagsToString & " [group: " & Database.GetByIndex(TempIndex).Group & "]", User.Username, Whisper, InBot
                    Else
                        SendMessage "Found user " & AddQuotes(Args) & " => " & Database.GetByIndex(TempIndex).FlagsToString, User.Username, Whisper, InBot
                    End If
                Else
                    SendMessage "User " & AddQuotes(Args) & " was not found in the database.", User.Username, Whisper, InBot
                End If
            End If
        End If
    Case "findattr"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            If Args = vbNullString Then Exit Sub
            For I = 0 To Database.Count
                If InStrB(Database.GetByIndex(I).FlagsToString, UCase$(Args)) <> 0 Then
                    Confirm = True
                    Count = Count + 1
                    ListingUsers = ListingUsers + Database.GetByIndex(I).Username & " => " & Database.GetByIndex(I).FlagsToString & ", "
                    If (Count = 6) Or Database.Count = I And Confirm = True Then
                        SendMessage "Found Users: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                        ListingUsers = vbNullString
                        Count = 0
                    End If
                Else
                    If (Count = 6) Or Database.Count = I And Confirm = True And ListingUsers <> vbNullString Then
                        SendMessage "Found Users: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                        ListingUsers = vbNullString
                        Count = 0
                    End If
                End If
            Next I
            If Count = 0 And Confirm = False Then
                SendMessage "There are no users in the database with the flags of " & AddQuotes(UCase$(Args)), User.Username, Whisper, InBot
            End If
        End If
    
    Case "findby"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            Dim SearchUser As String
            If Args = vbNullString Then Exit Sub
            
            For I = 0 To Database.Count
                If (LenB(Database.GetByIndex(I).ModifiedBy) > 0) Then
                    SearchUser = Database.GetByIndex(I).ModifiedBy
                Else
                    SearchUser = Database.GetByIndex(I).Addedby
                End If
                
                If InStrB(LCase$(SearchUser), LCase$(Args)) <> 0 Then
                    Confirm = True
                    Count = Count + 1
                    ListingUsers = ListingUsers + Database.GetByIndex(I).Username & " => " & Database.GetByIndex(I).FlagsToString & ", "
                    If (Count = 6) Or Database.Count = I And Confirm = True Then
                        SendMessage "Found Users: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                        ListingUsers = vbNullString
                        Count = 0
                    End If
                Else
                    If (Count = 6) Or Database.Count = I And Confirm = True And ListingUsers <> vbNullString Then
                        SendMessage "Found Users: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                        ListingUsers = vbNullString
                        Count = 0
                    End If
                End If
            Next I
            If Count = 0 And Confirm = False Then
                SendMessage "There are no users in the database that have been set by " & AddQuotes(Args), User.Username, Whisper, InBot
            End If
        End If
        
    Case "findext", "finduserext", "extu"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            TempIndex = Database.Find(Args)
            If (TempIndex <> -1) Then
                If (LenB(Database.GetByIndex(TempIndex).ModifiedBy) > 0) Then
                    ModifiedBy = " modified by: " & Database.GetByIndex(TempIndex).ModifiedBy
                Else
                    ModifiedBy = " added by: " & Database.GetByIndex(TempIndex).Addedby
                End If
                
                If Database.GetByIndex(TempIndex).Group <> vbNullString Then
                    SendMessage "Found user " & AddQuotes(Args) & " => " & Database.GetByIndex(TempIndex).FlagsToString & " [group: " & Database.GetByIndex(TempIndex).Group & "]" & ModifiedBy & " on " & Database.GetByIndex(TempIndex).AddedDate & " @ " & Database.GetByIndex(TempIndex).AddedTime, User.Username, Whisper, InBot
                Else
                    SendMessage "Found user " & AddQuotes(Args) & " => " & Database.GetByIndex(TempIndex).FlagsToString & ModifiedBy & " on " & Database.GetByIndex(TempIndex).AddedDate & " @ " & Database.GetByIndex(TempIndex).AddedTime, User.Username, Whisper, InBot
                End If
            Else
                SendMessage "User " & AddQuotes(Args) & " was not found in the database.", User.Username, Whisper, InBot
            End If
        End If
        
    Case "listgroups", "listg"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            If Groups.GetByIndex(0).Groupname = vbNullString Then
                SendMessage "There are no groups in the group list.", User.Username, Whisper, InBot
                Exit Sub
            End If
            For I = 0 To Groups.Count
                Count = Count + 1
                ListingUsers = ListingUsers + Groups.GetByIndex(I).Groupname & " => " & Groups.GetByIndex(I).AttributeString & ", "
                If (Count = 6) Or Groups.Count = I Then
                    SendMessage "Found Groups: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                    ListingUsers = vbNullString
                    Count = 0
                End If
            Next I
        End If
        
    Case "findgroup", "findg"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            TempIndex = Groups.Find(Args)
            If Args = vbNullString Then Exit Sub
            If InStr(Args, "*") <> 0 Then
                For I = 0 To Groups.Count
                    If Matches(Groups.GetByIndex(I).Groupname, Args) = True Then
                        Confirm = True
                        Count = Count + 1
                        ListingUsers = ListingUsers + Groups.GetByIndex(I).Groupname & " => " & Groups.GetByIndex(I).AttributeString & ", "
                        If (Count = 6) Or Groups.Count = I And Confirm = True Then
                            SendMessage "Found Groups: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                            ListingUsers = vbNullString
                            Count = 0
                        End If
                    Else
                        If (Count = 6) Or Groups.Count = I And Confirm = True Then
                            SendMessage "Found Groups: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                            ListingUsers = vbNullString
                            Count = 0
                        End If
                    End If
                Next I
                If Count = 0 And Confirm = False Then
                    SendMessage "There are no groups in the group list that are similar to " & AddQuotes(Args), User.Username, Whisper, InBot
                End If
            Else
                If (TempIndex <> -1) Then
                    SendMessage "Found group " & AddQuotes(Args) & " => " & Groups.GetByIndex(TempIndex).AttributeString, User.Username, Whisper, InBot
                Else
                    SendMessage "Group " & AddQuotes(Args) & " was not found in the group list.", User.Username, Whisper, InBot
                End If
            End If
        End If
    Case "findgext", "findgroupext", "extg"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            TempIndex = Groups.Find(Args)
            If (TempIndex <> -1) Then
                SendMessage "Found group " & AddQuotes(Args) & " => " & Groups.GetByIndex(TempIndex).AttributeString & " added by " & Groups.GetByIndex(TempIndex).Addedby & " on " & Groups.GetByIndex(TempIndex).AddedDate & " @ " & Groups.GetByIndex(TempIndex).AddedTime, User.Username, Whisper, InBot
            Else
                SendMessage "Group " & AddQuotes(Args) & " was not found in the group list.", User.Username, Whisper, InBot
            End If
        End If
    Case "uptime", "systemuptime"
        If (ATTR_I And User.Flags) = ATTR_I Then
            On Error Resume Next
            If (ConnectedTime <> 0) Then SendMessage "System: " & DateTimeToLongString(ConvertTickCount(DblTickCount), True) & " - Connection: " & DateTimeToLongString(ConvertTickCount(DblTickCount - ConnectedTime), True), User.Username, Whisper, InBot
            If (ConnectedTime = 0) Then SendMessage "System: " & DateTimeToLongString(ConvertTickCount(DblTickCount), True), User.Username, Whisper, InBot
        End If
    Case "dbcount", "databasecount"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            If Database.Count = 0 Then
                SendMessage "There are no users in the database.", User.Username, Whisper, InBot
            Else
                SendMessage "There are currently " & Database.Count + 1 & " users in the database.", User.Username, Whisper, InBot
            End If
        End If
    Case "grpcount", "groupcount"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            If Groups.GetByIndex(0).Groupname = vbNullString Then
                SendMessage "There are no groups in the group list.", User.Username, Whisper, InBot
                Exit Sub
            End If
            
            SendMessage "There are currently " & Groups.Count + 1 & " groups in the group list.", User.Username, Whisper, InBot
        End If
    Case "whoami", "findme"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            TempIndex = Database.Find(User.Username)
            If (LenB(Database.GetByIndex(TempIndex).ModifiedBy) > 0) Then
                ModifiedBy = " modified by: " & Database.GetByIndex(TempIndex).ModifiedBy
            Else
                ModifiedBy = " added by: " & Database.GetByIndex(TempIndex).Addedby
            End If
            
            If User.Group <> vbNullString Then
                SendMessage "You are: " & AddQuotes(User.Username) & " => " & User.FlagsToString & " [group: " & User.Group & "]" & ModifiedBy & " on " & Database.GetByIndex(TempIndex).AddedDate & " @ " & Database.GetByIndex(TempIndex).AddedTime, User.Username, Whisper, InBot
            Else
                SendMessage "You are: " & AddQuotes(User.Username) & " => " & User.FlagsToString & ModifiedBy & " on " & Database.GetByIndex(TempIndex).AddedDate & " @ " & Database.GetByIndex(TempIndex).AddedTime, User.Username, Whisper, InBot
            End If
        End If
    Case "ver", "version", "about"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            SendMessage "Knight (" & Version & ") developed by vuther.de & Mike.de", User.Username, Whisper, InBot
        End If
    Case "ping"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            If (Args = vbNullString) Then
                SendMessage "You have a reported ping of " & Ping & "ms.", User.Username, Whisper, InBot
            Else
                If Users.Find(Args) = -1 Then
                    SendMessage Args & " is not in the channel to be pinged.", User.Username, Whisper, InBot
                Else
                    SendMessage Args & " has a reported ping of " & Users.GetByName(Args).Ping & ".", User.Username, Whisper, InBot
                End If
            End If
        End If
    Case "cq", "clearqueue"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            ClearQueue
        End If
    Case "banned"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            Splt = Split(Args, Space$(1))
            If UBound(Splt) = 0 Then Args = Args
            If UBound(Splt) = 1 Then Args = Splt(0)
            
            If Args = vbNullString Then Exit Sub
            
            If LCase$(Splt(0)) = "list" Then
                If Banlist.GetByIndex(0).Username = vbNullString Then
                    SendMessage "There are no users in the banned list.", User.Username, Whisper, InBot
                    Exit Sub
                End If
                For BanCount = 0 To Banlist.Count
                    Count = Count + 1
                    ListingUsers = ListingUsers + Banlist.GetByIndex(BanCount).Username & ", "
            
                    If (Count = 6) Or Banlist.Count = BanCount Then
                        SendMessage "Found Banned: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                        ListingUsers = vbNullString
                        Count = 0
                    End If
                Next BanCount
            ElseIf LCase$(Splt(0)) = "rem" Then
                If UBound(Splt) <> 1 Then Exit Sub
                If Banlist.Remove(Splt(1)) = True Then
                    SendMessage Splt(1) & " has been removed from the banlist!", User.Username, Whisper, InBot
                Else
                    SendMessage "That user is not in the ban list.", User.Username, Whisper, InBot
                End If
            ElseIf LCase$(Splt(0)) = "count" Then
                If Banlist.GetByIndex(0).Username = vbNullString Then
                    SendMessage "There are no users in the banned list.", User.Username, Whisper, InBot
                Else
                    SendMessage "There are currently " & Banlist.Count + 1 & " users in the banlist.", User.Username, Whisper, InBot
                End If
            ElseIf LCase$(Splt(0)) = "clear" Then
                Banlist.Clear
                SendMessage "The ban list has been cleared!", User.Username, Whisper, InBot
            End If
        End If
    Case "os"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            Dim OS As String, Build As String, ServicePack As String, VersionNumber As String, Edition As String
            
            OS = GetString(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows NT\CurrentVersion\", "ProductName")
            Build = GetString(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows NT\CurrentVersion\", "CurrentBuild")
            VersionNumber = GetString(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows NT\CurrentVersion\", "CurrentVersion")
            ServicePack = GetString(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows NT\CurrentVersion\", "CSDVersion")
            Edition = GetString(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows NT\CurrentVersion\", "EditionID")

            SendMessage "OS: " & OS & ", " & ServicePack & " (version " & VersionNumber & ")", User.Username, Whisper, InBot
        End If
    Case "status"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            SendMessage "Status ; ipban: [" & Config.IPBan & "] - shortvisit ban: [" & Config.ShortVisit & "] - fast join talk: [" & Config.FastJoin & "] - pingban: [" & Config.Pingban & "] - lockdown: [" & Config.Lockdown & "] - spamban: [" & Config.Spamban & "] - remote channel: [" & Config.RemoteChannel & "]", User.Username, Whisper, InBot
        End If
        
    Case "lastwhisper", "lw"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            If LastWhisper = vbNullString Then
                SendMessage "No user has whispered me yet.", User.Username, Whisper, InBot
            Else
                SendMessage LastWhisper & " was the last person to whisper me.", User.Username, Whisper, InBot
            End If
        End If
        
    Case "stats"
         If ((ATTR_I And User.Flags) = ATTR_I) Then
            SendMessage "Statistics ; " & "database: " & countUserMod & "/group list: " & countGroupMod & " - received whispers: " & countWhisper & " - banned: " & countBanned & " - unbanned: " & countUnbanned, User.Username, Whisper, InBot
         End If
    
    Case "checkfriends", "cf"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            For I = 0 To Users.Count
                If Database.Safelist(Users.GetByIndex(I).Username) = False And Database.Friended(Users.GetByIndex(I).Username) = False Then
                    If LCase$(Users.GetByIndex(I).Username) <> LCase$(Username) Then
                        Confirm = True
                        Count = Count + 1
                        ListingUsers = ListingUsers + Users.GetByIndex(I).Username & ", "
                        If (Count = 6) Or Users.Count = I And Confirm = True Then
                            SendMessage "Found Users: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                            ListingUsers = vbNullString
                            Count = 0
                        End If
                    End If
                Else
                    If (Count = 6) Or Users.Count = I And Confirm = True And ListingUsers <> vbNullString Then
                        SendMessage "Found Users: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                        ListingUsers = vbNullString
                        Count = 0
                    End If
                End If
            Next I
            If Count = 0 And Confirm = False Then
                SendMessage "Everyone in the channel is already a friend or safelisted.", User.Username, Whisper, InBot
            End If
        End If
    Case "shamans"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            If Warcraft3 Then
                For I = 0 To Clan.Count
                    If Clan.GetByIndex(I).ClanRank = &H3 Then
                        Confirm = True
                        Count = Count + 1
                        ListingUsers = ListingUsers + Clan.GetByIndex(I).Username & ", "
                        If (Count = 6) Or Clan.Count = I And Confirm = True Then
                            SendMessage "Found Shamans: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                            ListingUsers = vbNullString
                            Count = 0
                        End If
                    Else
                        If (Count = 6) Or Clan.Count = I And Confirm = True And ListingUsers <> vbNullString Then
                            SendMessage "Found Shamans: " & Left(ListingUsers, Len(ListingUsers) - 2), User.Username, Whisper, InBot
                            ListingUsers = vbNullString
                            Count = 0
                        End If
                    End If
                Next I
                If Count = 0 And Confirm = False Then
                    SendMessage "There are no Shamans in this clan.", User.Username, Whisper, InBot
                End If
            End If
        End If
    Case "clancount", "cc"
         If ((ATTR_I And User.Flags) = ATTR_I) Then
            If Warcraft3 Then
                SendMessage "There are " & Clan.Count + 1 & " members in this clan.", User.Username, Whisper, InBot
            Else
                SendMessage "I must be on Warcraft III to do that.", User.Username, Whisper, InBot
            End If
        End If
    Case "claninfo", "ci"
        If ((ATTR_I And User.Flags) = ATTR_I) Then
            If Warcraft3 Then
                If Args <> vbNullString Then
                    ClanInvite.UserWhoInvited = User.Username
                    ClanInvite.InBot = InBot
                    ClanInvite.IsWhisper = Whisper
                    ClanInvite.InvitedUser = Args
                    SendMemberInfo Args
                End If
            Else
                SendMessage "I must be on Warcraft III to do that.", User.Username, Whisper, InBot
            End If
        End If
' Flag O
    Case "ban"
        If ((ATTR_O And User.Flags) = ATTR_O) Then
            Splt = Split(Args, Space$(1), 2)
            If UBound(Splt) = 0 Then TempIndex = Users.Find(Args): TempString = Args
            If UBound(Splt) = 1 Then TempIndex = Users.Find(Splt(0)): TempString = Splt(0)
            Args = RemoveChars(Args)
            If InStr(Args, "*") <> 0 Then
                For I = 0 To Users.Count
                    If Matches(Users.GetByIndex(I).Username, TempString) = True Then
                        If Database.Safelist(Users.GetByIndex(I).Username) = False Then
                            Confirm = True
                            
                            If UBound(Splt) = 0 Then SendMessage "/ban " & Users.GetByIndex(I).Username, User.Username, False, False
                            If UBound(Splt) = 1 Then SendMessage "/ban " & Users.GetByIndex(I).Username & Space(1) & Splt(1), User.Username, False, False
                        End If
                    End If
                Next I
                If Confirm = False Then
                    SendMessage "No users in the channel are eligble to be banned using this specified criteria: " & AddQuotes(TempString) & ".", User.Username, Whisper, InBot
                End If
            Else
                If (TempIndex <> -1) Then
                    If UBound(Splt) = 0 Then
                        If (Database.Safelist(Args)) = True Then
                            SendMessage Args & " is safelisted, you cannot ban him.", User.Username, Whisper, InBot
                            Exit Sub
                        End If
                        SendMessage "/ban " & Args, User.Username, False, False
                    End If
                    
                    If UBound(Splt) = 1 Then
                        If (Database.Safelist(Splt(0))) = True Then
                            SendMessage TempString & " is safelisted, you cannot ban him.", User.Username, Whisper, InBot
                            Exit Sub
                        End If
                        SendMessage "/ban " & Args, User.Username, False, False
                    End If
                Else
                    If UBound(Splt) = 0 Then
                        If (Database.Safelist(Args)) = True Then
                            SendMessage Args & " is safelisted, you cannot ban him.", User.Username, Whisper, InBot
                            Exit Sub
                        End If
                        SendMessage "/ban " & Args, User.Username, False, False
                    End If
                    If UBound(Splt) = 1 Then
                        If (Database.Safelist(Splt(0))) = True Then
                            SendMessage TempString & " is safelisted, you cannot ban him.", User.Username, Whisper, InBot
                            Exit Sub
                        End If
                        SendMessage "/ban " & Args, User.Username, False, False
                    End If
                End If
            End If
        End If
    Case "kick"
        If ((ATTR_O And User.Flags) = ATTR_O) Then
            Splt = Split(Args, Space$(1), 2)
            If UBound(Splt) = 0 Then TempIndex = Users.Find(Args): TempString = Args
            If UBound(Splt) = 1 Then TempIndex = Users.Find(Splt(0)): TempString = Splt(0)
            Args = RemoveChars(Args)
            If InStr(Args, "*") <> 0 Then
                For I = 0 To Users.Count
                    If Matches(Users.GetByIndex(I).Username, TempString) = True Then
                        If Database.Safelist(Users.GetByIndex(I).Username) = False And Database.Friended(Users.GetByIndex(I).Username) = False Then
                            Confirm = True
                            If UBound(Splt) = 0 Then SendMessage "/kick " & Users.GetByIndex(I).Username, User.Username, False, False
                            If UBound(Splt) = 1 Then SendMessage "/kick " & Users.GetByIndex(I).Username & Space(1) & Splt(1), User.Username, False, False
                        End If
                    End If
                Next I
                If Confirm = False Then
                    SendMessage "No users in the channel are eligble to be kicked using this specified criteria: " & AddQuotes(TempString) & ".", User.Username, Whisper, InBot
                End If
            Else
                If (TempIndex <> -1) Then
                    If UBound(Splt) = 0 Then
                        If (Database.Safelist(Args)) = True Then
                            SendMessage Args & " is safelisted, you cannot kick him.", User.Username, Whisper, InBot
                            Exit Sub
                        End If
                        SendMessage "/kick " & Args, User.Username, False, False
                    End If
                    
                    If UBound(Splt) = 1 Then
                        If (Database.Safelist(Splt(0))) = True Then
                            SendMessage TempString & " is safelisted, you cannot kick him.", User.Username, Whisper, InBot
                           Exit Sub
                        End If
                        SendMessage "/kick " & Args, User.Username, False, False
                    End If
                Else
                    If UBound(Splt) = 0 Then
                        If (Database.Safelist(Args)) = True Then
                            SendMessage Args & " is safelisted, you cannot kick him.", User.Username, Whisper, InBot
                            Exit Sub
                        End If
                        SendMessage "/kick " & Args, User.Username, False, False
                    End If
                    If UBound(Splt) = 1 Then
                        If (Database.Safelist(Splt(0))) = True Then
                            SendMessage TempString & " is safelisted, you cannot kick him.", User.Username, Whisper, InBot
                            Exit Sub
                        End If
                        SendMessage "/kick " & Args, User.Username, False, False
                    End If
                End If
            End If
        End If
    Case "unban"
        If ((ATTR_O And User.Flags) = ATTR_O) Then
            If InStr(Args, "*") <> 0 Then
                For BanCount = 0 To Banlist.Count
                    If Matches(Banlist.GetByIndex(BanCount).Username, Args) = True Then
                        Confirm = True
                        SendMessage "/unban " & Banlist.GetByIndex(BanCount).Username, User.Username, False, False
                    End If
                Next BanCount
                If Confirm = False Then
                    SendMessage "No users in the channel are eligble to be unbanned using this specified criteria: " & AddQuotes(Args) & ".", User.Username, Whisper, InBot
                End If
            Else
                If (TempIndex <> -1) Then
                    SendMessage "/unban " & Args, User.Username, False, False
                End If
            End If
        End If
    Case "ubl", "unbanlast"
        If ((ATTR_O And User.Flags) = ATTR_O) Then
            If Banlist.GetByIndex(Banlist.Count).Username = vbNullString Then
                SendMessage "No users have been banned in the channel yet.", User.Username, Whisper, InBot
            Else
                SendMessage "/unban " & Banlist.GetByIndex(Banlist.Count).Username, User.Username, False, False
            End If
        End If
    Case "say"
        If ((ATTR_O And User.Flags) = ATTR_O) Then
            If Left$(Args, 1) = "/" And Not ((ATTR_A And User.Flags) = ATTR_A) Then Args = Space$(1) & Args
            SendMessage Args, User.Username, False, False
            AddChat vbCyan, Username & ": ", vbWhite, Args
        End If
        
    Case "sweepban", "sweep"
         If ((ATTR_O And User.Flags) = ATTR_O) Then
            If Args = vbNullString Then
                SendMessage "You must input a channel to sweep through.", User.Username, Whisper, InBot
                Exit Sub
            Else
                Sweepban = True
                SendMessage "/who " & Args, User.Username, False, False
                SendMessage "/w " & Username & " Sweepban!", False, False
            End If
        End If
    Case "block", "ip"
         If ((ATTR_O And User.Flags) = ATTR_O) Then
            If Database.GetByName(Args).Safelisted = False Then
                AddQ "/ignore " & Args
            End If
         End If
         
' Flag M
    Case "shortvisit", "svt"
        If ((ATTR_M And User.Flags) = ATTR_M) Then
            Splt = Split(Args, Space$(1))
            If UBound(Splt) = 0 Then Args = Args
            If UBound(Splt) = 1 Then Args = Splt(0)
            
            If LCase$(Args) = "on" Then
                If ShortVisit = True Then
                    SendMessage "Shortvisit ban is already enabled.", User.Username, Whisper, InBot
                Else
                    Config.ShortVisit = Args
                    ShortVisit = True
                    SendMessage "Shortvisit ban has been enabled!", User.Username, Whisper, InBot
                End If
            ElseIf LCase$(Args) = "off" Then
                If ShortVisit = False Then
                    SendMessage "Shortvisit ban is already disabled.", User.Username, Whisper, InBot
                Else
                    SendMessage "Shortvisit ban has been disabled.", User.Username, Whisper, InBot
                    ShortVisit = False
                    Config.ShortVisit = Args
                End If
            ElseIf LCase$(Args) = "set" Then
                If UBound(Splt) = 1 Then
                    If Splt(1) = vbNullString Then
                        SendMessage "You must specify a valid value to change the interval for shortvisit ban.", User.Username, Whisper, InBot
                    Else
                        ShortVisitTime = Splt(1)
                        Config.ShortVisitTime = Splt(1)
                        SendMessage "Shortvisit ban's interval has been set to " & Splt(1) & "ms.", User.Username, Whisper, InBot
                    End If
                End If
            ElseIf LCase$(Args) = vbNullString Then
                If ShortVisit = True Then
                    SendMessage "Shortvisit ban is enabled with a interval of " & ShortVisitTime & "ms.", User.Username, Whisper, InBot
                ElseIf ShortVisit = False Then
                    SendMessage "Shortvisit ban is disabled.", User.Username, Whisper, InBot
                End If
            End If
        End If
    Case "lockdown", "ld"
        If ((ATTR_M And User.Flags) = ATTR_M) Then
            Splt = Split(Args, Space$(1), 2)
            If UBound(Splt) = 0 Then Args = Args
            If UBound(Splt) = 1 Then Args = Splt(0)
            If UBound(Splt) = 2 Then Args = Splt(1)
            
            If LCase$(Args) = "on" Then
                If Lockdown = True Then
                    SendMessage "Lockdown is already enabled.", User.Username, Whisper, InBot
                Else
                    Config.Lockdown = Args
                    Lockdown = True
                    SendMessage "Lockdown has been enabled!", User.Username, Whisper, InBot
                    InitProtection False
                End If
            ElseIf LCase$(Args) = "off" Then
                If Lockdown = False Then
                    SendMessage "Lockdown is already disabled.", User.Username, Whisper, InBot
                Else
                    SendMessage "Lockdown has been disabled.", User.Username, Whisper, InBot
                    Config.Lockdown = Args
                    Lockdown = False
                End If
            ElseIf LCase$(Args) = "msg" Then
                If UBound(Splt) <> 1 Then
                    SendMessage "You must specify a valid message.", User.Username, Whisper, InBot
                    Exit Sub
                End If
                    LockdownMessage = Splt(1)
                    Config.LockdownMessage = Splt(1)
                    SendMessage "Lockdown message has been set to " & AddQuotes(Splt(1)), User.Username, Whisper, InBot
            ElseIf LCase$(Args) = vbNullString Then
                If Lockdown = True Then
                    SendMessage "Lockdown is enabled, the ban message is: " & Config.LockdownMessage, User.Username, Whisper, InBot
                ElseIf Lockdown = False Then
                    SendMessage "Lockdown is disabled.", User.Username, Whisper, InBot
                End If
            End If
        End If
    Case "ipban"
        If ((ATTR_M And User.Flags) = ATTR_M) Then
            If LCase$(Args) = "on" Then
                If IPBan = True Then
                    SendMessage "IPBan is already enabled.", User.Username, Whisper, InBot
                Else
                    Config.IPBan = Args
                    IPBan = True
                    SendMessage "IPBan has been enabled!", User.Username, Whisper, InBot
                End If
            ElseIf LCase$(Args) = "off" Then
                If IPBan = False Then
                    SendMessage "IPBan is already disabled.", User.Username, Whisper, InBot
                Else
                    SendMessage "IPBan has been disabled.", User.Username, Whisper, InBot
                    IPBan = False
                    Config.IPBan = Args
                End If
            ElseIf LCase$(Args) = vbNullString Then
                If IPBan = True Then
                    SendMessage "IPBan is enabled.", User.Username, Whisper, InBot
                ElseIf IPBan = False Then
                    SendMessage "IPBan is disabled.", User.Username, Whisper, InBot
                End If
            End If
        End If
    Case "fastjtalk", "fjt"
        If ((ATTR_M And User.Flags) = ATTR_M) Then
            Splt = Split(Args, Space$(1))
            If UBound(Splt) = 0 Then Args = Args
            If UBound(Splt) = 1 Then Args = Splt(0)
            
            If LCase$(Args) = "on" Then
                If FastJoin = True Then
                    SendMessage "Fast join talk is already enabled.", User.Username, Whisper, InBot
                Else
                    Config.FastJoin = Args
                    FastJoin = True
                    SendMessage "Fast join talk has been enabled!", User.Username, Whisper, InBot
                End If
            ElseIf LCase$(Args) = "off" Then
                If FastJoin = False Then
                    SendMessage "Fast join talk is already disabled.", User.Username, Whisper, InBot
                Else
                    SendMessage "Fast join talk has been disabled.", User.Username, Whisper, InBot
                    Config.FastJoin = Args
                    FastJoin = False
                End If
            ElseIf LCase$(Args) = "set" Then
                If UBound(Splt) = 1 Then
                    If Splt(1) = vbNullString Then
                        SendMessage "You must specify a valid value to change the interval for fast join talk.", User.Username, Whisper, InBot
                    Else
                        FastJoinTime = Splt(1)
                        Config.FastJoinTime = Splt(1)
                        SendMessage "Fast join talk's interval has been set to " & Splt(1) & "ms.", User.Username, Whisper, InBot
                    End If
                End If
            ElseIf LCase$(Args) = vbNullString Then
                If FastJoin = True Then
                    SendMessage "Fast join talk is enabled with a interval of " & FastJoinTime & "ms.", User.Username, Whisper, InBot
                ElseIf FastJoin = False Then
                    SendMessage "Fast join talk is disabled.", User.Username, Whisper, InBot
                End If
            End If
        End If
    Case "spamban", "sb"
        If ((ATTR_M And User.Flags) = ATTR_M) Then
            If LCase$(Args) = "on" Then
                If Spamban = True Then
                    SendMessage "Spamban is already enabled.", User.Username, Whisper, InBot
                Else
                    Config.Spamban = Args
                    Spamban = True
                    SendMessage "Spamban has been enabled!", User.Username, Whisper, InBot
                End If
            ElseIf LCase$(Args) = "off" Then
                If Spamban = False Then
                    SendMessage "Spamban is already disabled.", User.Username, Whisper, InBot
                Else
                    SendMessage "Spamban has been disabled.", User.Username, Whisper, InBot
                    Spamban = False
                    Config.Spamban = Args
                End If
            ElseIf LCase$(Args) = vbNullString Then
                If Spamban = True Then
                    SendMessage "Spamban is enabled.", User.Username, Whisper, InBot
                ElseIf Spamban = False Then
                    SendMessage "Spamban is disabled.", User.Username, Whisper, InBot
                End If
            End If
        End If
    Case "remotechannel", "rc"
        If ((ATTR_M And User.Flags) = ATTR_M) Then
            If LCase$(Args) = "on" Then
                If RemoteChannel = True Then
                    SendMessage "Remote channel is already enabled.", User.Username, Whisper, InBot
                Else
                    Config.RemoteChannel = Args
                    RemoteChannel = True
                    SendMessage "Remote channel has been enabled!", User.Username, Whisper, InBot
                End If
            ElseIf LCase$(Args) = "off" Then
                If RemoteChannel = False Then
                    SendMessage "Remote channel is already disabled.", User.Username, Whisper, InBot
                Else
                    SendMessage "Remote channel has been disabled.", User.Username, Whisper, InBot
                    RemoteChannel = False
                    Config.RemoteChannel = Args
                End If
            ElseIf LCase$(Args) = vbNullString Then
                If RemoteChannel = True Then
                    SendMessage "Remote channel is enabled.", User.Username, Whisper, InBot
                ElseIf RemoteChannel = False Then
                    SendMessage "Remote channel is disabled.", User.Username, Whisper, InBot
                End If
            End If
        End If
    Case "pingban", "pb"
        If ((ATTR_M And User.Flags) = ATTR_M) Then
            Splt = Split(Args, Space$(1))
            If UBound(Splt) = 0 Then Args = Args
            If UBound(Splt) = 1 Then Args = Splt(0)
            
            If LCase$(Args) = "on" Then
                If Pingban = True Then
                    SendMessage "Pingban is already enabled.", User.Username, Whisper, InBot
                Else
                    Config.Pingban = Args
                    Pingban = True
                    SendMessage "Pingban has been enabled!", User.Username, Whisper, InBot
                End If
            ElseIf LCase$(Args) = "off" Then
                If Pingban = False Then
                    SendMessage "Pingban is already disabled.", User.Username, Whisper, InBot
                Else
                    SendMessage "Pingban has been disabled.", User.Username, Whisper, InBot
                    Config.Pingban = Args
                    Pingban = False
                End If
            ElseIf LCase$(Args) = "set" Then
                If UBound(Splt) = 1 Then
                    If Splt(1) = vbNullString Then
                        SendMessage "You must specify a valid value to change the limit for Pingban.", User.Username, Whisper, InBot
                    Else
                        PingbanLimit = Splt(1)
                        Config.PingbanLimit = Splt(1)
                        SendMessage "Pingban's limit has been set to " & Splt(1) & "ms.", User.Username, Whisper, InBot
                    End If
                End If
            ElseIf LCase$(Args) = vbNullString Then
                If Pingban = True Then
                    SendMessage "Pingban is enabled with a limit of " & PingbanLimit & "ms.", User.Username, Whisper, InBot
                ElseIf Pingban = False Then
                    SendMessage "Pingban is disabled.", User.Username, Whisper, InBot
                End If
            End If
        End If
' Flag N
    Case "invite", "inviteuser", "claninvite"
        If ((ATTR_N And User.Flags) = ATTR_N) Then
            If Warcraft3 Then
                If Args <> vbNullString Then
                    ClanInvite.UserWhoInvited = User.Username
                    ClanInvite.InBot = InBot
                    ClanInvite.IsWhisper = Whisper
                    ClanInvite.InvitedUser = Args
                    SendClanInvite Args
                    SendMessage "Inviting " & AddQuotes(Args) & " to the clan.", User.Username, Whisper, InBot
                End If
            Else
                SendMessage "I must be on Warcraft III to do that.", User.Username, Whisper, InBot
            End If
        End If
    Case "setrank"
        If ((ATTR_N And User.Flags) = ATTR_N) Then
            Splt = Split(Args, Space$(1))
            If UBound(Splt) = 0 Then Args = Args
            If UBound(Splt) = 1 Then Args = Splt(0)
            
            If Warcraft3 Then
                If Args <> vbNullString Then
                    ClanInvite.UserWhoInvited = User.Username
                    ClanInvite.InBot = InBot
                    ClanInvite.IsWhisper = Whisper
                    ClanInvite.InvitedUser = Args
                    If LCase$(Splt(1)) = "peon" Then
                        SendRankChange Splt(0), &H1
                    ElseIf LCase$(Splt(1)) = "grunt" Then
                        SendRankChange Splt(0), &H2
                    ElseIf LCase$(Splt(1)) = "shaman" Then
                        SendRankChange Splt(0), &H3
                    End If
                End If
            Else
                SendMessage "I must be on Warcraft III to do that.", User.Username, Whisper, InBot
            End If
        End If
     Case "kickmember"
        If ((ATTR_N And User.Flags) = ATTR_N) Then
            If Warcraft3 Then
                If Args <> vbNullString Then
                    ClanInvite.UserWhoInvited = User.Username
                    ClanInvite.InBot = InBot
                    ClanInvite.IsWhisper = Whisper
                    ClanInvite.InvitedUser = Args
                    SendMemberRemove Args
                End If
            Else
                SendMessage "I must be on Warcraft III to do that.", User.Username, Whisper, InBot
            End If
        End If
    Case "clanprivate", "cp"
        If ((ATTR_N And User.Flags) = ATTR_N) Then
            If Warcraft3 Then
                If Args = "on" Then
                    SendMessage "The clan channel is now private.", User.Username, Whisper, InBot
                    AddQ "/clan private"
                ElseIf Args = "off" Then
                    SendMessage "The clan channel is now public.", User.Username, Whisper, InBot
                    AddQ "/clan public"
                End If
            Else
                SendMessage "I must be on Warcraft III to do that.", User.Username, Whisper, InBot
            End If
        End If
' Flag X
    Case "op", "giveops"
        If ((ATTR_X And User.Flags) = ATTR_X) Then
            If Users.Find(Args) = -1 Then
                SendMessage Args & " is not in the channel to be designated.", User.Username, Whisper, InBot
            Else
                SendMessage "/designate " & Args, User.Username, False, False
                SendMessage "/resign", User.Username, False, False
            End If
        End If
    Case "designate"
        If ((ATTR_X And User.Flags) = ATTR_X) Then
            If Users.Find(Args) = -1 Then
                SendMessage Args & " is not in the channel to be designated.", User.Username, Whisper, InBot
            Else
                SendMessage "/designate " & Args, User.Username, False, False
            End If
        End If
    Case "resign", "rejoin"
        If ((ATTR_X And User.Flags) = ATTR_X) Then
            With PBuffer
                .SendBNCS &H10
                .InsertDWORD &H2
                .InsertNTString CurrentChannel
                .SendBNCS &HC
            End With
        End If
    Case "ddp"
        If ((ATTR_X And User.Flags) = ATTR_X) Then
            If Warcraft3 = False Then
                SendMessage "I must be on Warcraft III to do that.", User.Username, Whisper, InBot
                Exit Sub
            ElseIf Users.Find(Args) = -1 Then
                SendMessage Args & " is not in the channel.", User.Username, Whisper, InBot
                Exit Sub
            ElseIf Clan.GetByName(Username).ClanRank <> &H4 Then
                SendMessage "I am not the chieftain of this clan.", User.Username, Whisper, InBot
                Exit Sub
            End If
            DDPUser = Args
            StartDDPTimer 1250
        End If

    Case "friend", "safe"
        Dim SafeFlag As String
        TempIndex = Database.Find(Args)
        
        If LCase$(Command) = "friend" Then
            SafeFlag = "F"
        Else
            SafeFlag = "S"
        End If
        
        If TempIndex = -1 Then
            If (Database.Add(Args, SafeFlag, , , , User.Username, , True, User.Flags)) Then
                SendMessage "Added user " & AddQuotes(Args) & " to the database with attributes of " & Database.GetByName(Args).AttributeString & "!", User.Username, Whisper, InBot
                countUserMod = countUserMod + 1
            Else
                SendMessage "You have insufficient access to add that user with those specified flags.", User.Username, Whisper, InBot
            End If
        Else
            If (Database.Update(User, vbNullString, TempIndex, SafeFlag)) Then
                If (Database.GetByIndex(TempIndex).Flags = 0) Then
                    SendMessage "All the flags for " & AddQuotes(Args) & " have been removed, user has been deleted.", User.Username, Whisper, InBot
                    Database.Remove Args
                Else
                    SendMessage "Added user " & AddQuotes(Args) & " to the database with attributes of " & Database.GetByName(Args).AttributeString & "!", User.Username, Whisper, InBot
                    countUserMod = countUserMod + 1
                End If
            Else
                SendMessage "You have insufficient access to add that user with those specified flags.", User.Username, Whisper, InBot
            End If
        End If
    End Select
End Sub

Public Sub SendMessage(Message As String, Optional Username As String, Optional Whisper As Boolean = False, Optional InBot As Boolean = False)

    If InBot = True Then
        AddChat vbYellow, Message
        Exit Sub
    End If

    If Whisper Then
        AddQ "/w " & Username & " " & Message
    Else
        AddQ Message
    End If

End Sub
