Attribute VB_Name = "modParseBNLS"
Option Explicit

Public Sub ParseBNLS(Data As String)

    Dim Buffer As New clsDebuffer
    Dim Packet As Byte, I As Long, Temp As Variant
    
    Buffer.DebuffPacket (Data)
    Buffer.Advance 2

    Packet = Buffer.DebuffBYTE

    Select Case (Packet)
    
        Case &H10: Handle_0x10 Buffer
        Case &HC: Handle_0x0C Buffer
        Case &H1A: Handle_0x1A Buffer
        Case &HB: Handle_0x0B Buffer
        Case &H2: Handle_0x02 Buffer
        Case &H3: Handle_0x03 Buffer
        Case &H4: Handle_0x04 Buffer
        Case &H7D: Handle_0x7D Buffer

    End Select
    
End Sub

Private Sub Handle_0x04(Buffer As clsDebuffer)
    
    SendBNCS0x52 Buffer.DebuffRaw(64)
    
End Sub

Private Sub Handle_0x02(Buffer As clsDebuffer)

    SendBNCS0x53 Buffer.DebuffRaw(32)

End Sub

Private Sub Handle_0x03(Buffer As clsDebuffer)

    SendBNCS0x54 Buffer.DebuffRaw(20)

End Sub

Private Sub Handle_0x0B(Buffer As clsDebuffer)

    If CreateAccount = False Then

        PasswordHash = Buffer.DebuffRaw(20)
        SendBNCS0x3A
        
    Else
        
        SendBNCS0x3D Buffer.DebuffRaw(20)
        
    End If

End Sub

Private Sub Handle_0x10(Buffer As clsDebuffer)

            Buffer.Advance 4
            VersionByte = Buffer.DebuffDWORD
            frmMain.sckBNCS.Connect Server, 6112
            AddChat vbGray, "Connecting to Battle.net..."
End Sub

Private Sub Handle_0x0C(Buffer As clsDebuffer)
    Dim Temp As Byte, I As Integer

            Buffer.Advance 6
            
            Buffer.Advance 4
                
            SessionCookie = Buffer.DebuffDWORD
            
            If ExpansionClient Then
            
                ReDim Preserve CDKeyData(1)
                CDKeyData(0) = Buffer.DebuffRaw(36)
                Buffer.Advance 4
                CDKeyData(1) = Buffer.DebuffRaw(36)
                
            Else
            
                ReDim Preserve CDKeyData(0)
                CDKeyData(0) = Buffer.DebuffRaw(36)
                
            End If
            
            SendBNLS0x1A
End Sub

Private Sub Handle_0x7D(Buffer As clsDebuffer)
Dim Usage As Byte
Dim Result As Byte
Dim Length As Integer
Dim Data As String
Dim Temp As New clsPBuffer

            Usage = Buffer.DebuffBYTE
            Buffer.Advance 4
            Result = Buffer.DebuffBYTE
            Length = Buffer.DebuffWORD
            Data = Buffer.DebuffRaw(Length)
            Select Case Usage
                Case &H0
                    If Result = &H0 Then
                        AddChat vbGreen, "Warden module is now initialized!"

                        If IgnoreWarden Then
                            With PBuffer
                            
                            .InsertBYTE &H1
                            .InsertDWORD WardenCookie
                            .InsertWORD Len(FirstWarden)
                            .InsertNonNTString FirstWarden
                            .SendBNLS &H7D
                            End With

                        End If
                        
                    End If
                
                Case &H1
              
                    Select Case Result
                        Case &H0
                        
                            If IgnoreWarden = False Then
                                If Len(Length) > 0 Then
                                    PBuffer.InsertNonNTString Data
                                    PBuffer.SendBNCS &H5E
                                End If
                                CurrentWarden = vbNullString
                            Else

                                IgnoreWarden = False
                                
                                With PBuffer
                                .InsertBYTE &H1
                                .InsertDWORD WardenCookie
                                .InsertWORD Len(CurrentWarden)
                                .InsertNonNTString CurrentWarden
                                .SendBNLS &H7D
                                End With
                                
                                CurrentWarden = vbNullString
                            End If
                        
                        Case &H1
                        
                        Case &H3
                                StartWardenTimer 10000
                            
                    End Select
            End Select
                    
End Sub

Private Sub Handle_0x1A(Buffer As clsDebuffer)

        Dim Temp As Long
            Temp = Buffer.DebuffDWORD
            If Temp = &H0 Then Exit Sub
            
            HashVersion = Buffer.DebuffDWORD
            HashChecksum = Buffer.DebuffDWORD
            HashString = Buffer.DebuffNTString
                        
            SendBNCS0x51
            
End Sub



