Attribute VB_Name = "modDeclares"
Option Explicit

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal numBytes As Long)
Public Declare Function GetTickCount Lib "kernel32.dll" () As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Boolean
Public Declare Function FileTimeToLocalFileTime Lib "kernel32" (lpFileTime As FILETIME, lpLocalFileTime As FILETIME) As Long
Public Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As Currency) As Long
Public Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As Currency) As Long
'Warden Calls
      Public Declare Sub WardenInit Lib "WardenHandler.dll" (ByVal sessionid As Long, ByVal clientid As Long, ByVal seed As Long)
      Public Declare Function WardenOnData Lib "WardenHandler.dll" (ByVal sessionid As Long, ByRef Data() As Byte) As Byte()
      Public Declare Sub WardenCleanup Lib "WardenHandler.dll" (ByVal sessionid As Long)

Public Profile As String

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Public PBuffer As New clsPBuffer
Public Users As New clsUsers
Public Database As New clsUserDatabase
Public Groups As New clsGroups
Public Banlist As New clsBanlist
Public Config As New clsConfig
Public Tray As New clsTrayIcon
Public Clan As New clsClanList
Public Queue As New clsQueue

Public Const vbGray = &HC0C0C0
Public Const vbAwesomeOrange = &HBFFF&
Public Const vbPurple = &HFF00FF

'User Variables
Public Server As String
Public Client As String
Public CDKey1 As String
Public CDKey2 As String
Public Username As String
Public Password As String
Public Channel As String
Public BNLSServer As String
Public Email As String
Public Trigger As String
Public Whisperback As Boolean

'Features
Public ShortVisit As Boolean
Public ShortVisitTime As Long
Public IPBan As Boolean
Public JoinCount As Integer
Public Sweepban As Boolean
Public Lockdown As Boolean
Public LockdownMessage As String
Public FastJoin As Boolean
Public FastJoinTick As Long
Public FastJoinTime As Long
Public RemoteChannel As Boolean
Public Pingban As Boolean
Public PingbanLimit As Long

Public OpsCount As Integer
Public OpTried As Boolean
Public Spamban As Boolean
Public Realm As String

'Internal Variables
Public D2 As Boolean
Public VersionByte As Long
Public LogonType As Long
Public ServerCookie As Long
Public UDPValue As Long
Public FileTimeHIGH As Long
Public FileTimeLOW As Long
Public MPQString As String
Public ValueString As String
Public SessionCookie As Long
Public CDKeyData() As String
Public HashVersion As Long
Public HashChecksum As Long
Public HashString As String
Public ExpansionClient As Boolean
Public PasswordHash As String
Public Warcraft3 As Boolean
Public StoredFirstWarden As Boolean
Public FirstWarden As String
Public CurrentWarden As String
Public WardenCookie As Long
Public IgnoreWarden As Boolean
Public WardenEnabled As Boolean
Public CreateAccount As Boolean
Public BNCSConnected As Boolean
Public ConnectedTime As Double
Public ForceReconnect As Boolean
Public LastWhisper As String
Public ClanInvite As InviteUser
Public countUserMod As Integer
Public countGroupMod As Integer
Public countWhisper As Integer
Public countBanned As Integer
Public countUnbanned As Integer
Public CurrentChannel As String

Public ClanTag As Long

Public Type InviteUser
    InvitedUser As String
    UserWhoInvited As String
    InBot As Boolean
    IsWhisper As Boolean
End Type

Public Type DATETIME
    Weeks As Long
    Days As Long
    Hours As Long
    Minutes As Long
    Seconds As Long
End Type

'Chat Event Identifiers
Public Const EID_SHOWUSER                   As Byte = &H1
Public Const EID_JOIN                       As Byte = &H2
Public Const EID_LEAVE                      As Byte = &H3
Public Const EID_WHISPER                    As Byte = &H4
Public Const EID_TALK                       As Byte = &H5
Public Const EID_BROADCAST                  As Byte = &H6
Public Const EID_CHANNEL                    As Byte = &H7
Public Const EID_USERFLAGS                  As Byte = &H9
Public Const EID_WHISPERSENT                As Byte = &HA
Public Const EID_CHANNELFULL                As Byte = &HD
Public Const EID_CHANNELDOESNOTEXIST        As Byte = &HE
Public Const EID_CHANNELRESTRICTED          As Byte = &HF
Public Const EID_INFO                       As Byte = &H12
Public Const EID_ERROR                      As Byte = &H13
Public Const EID_EMOTE                      As Byte = &H17
